Subject: [PATCH] userspace API definitions for auto-focus coil

From: [email-masked] (Pavel Machek)
Date: Sun, 12 Jun 2016 09:54:17 +0200

Hi!

> > >@@ -974,4 +975,9 @@ enum v4l2_detect_md_mode {
> > >  #define V4L2_CID_DETECT_MD_THRESHOLD_GRID	(V4L2_CID_DETECT_CLASS_BASE + 3)
> > >  #define V4L2_CID_DETECT_MD_REGION_GRID		(V4L2_CID_DETECT_CLASS_BASE + 4)
> > >
> > >+/* Control IDs specific to the AD5820 driver as defined by V4L2 */
> > >+#define V4L2_CID_FOCUS_AD5820_BASE 	(V4L2_CTRL_CLASS_CAMERA | 0x10af)
> 
> Please check V4L2_CID_USER_*_BASE. That's how custom controls are handled
> nowadays.

Let me see...

> Now that I think about this, the original implementation in N900 very likely
> did not use either of the two controls; the device driver was still written
> to provide access to full capabilities of the chip. And that one had no
> continuous AF.

I'm not sure about the original implementation, but fcam-dev library
(which is our best chance for usable camera) does use both:

pavel at duo:~/g/fcam-dev$ grep -ri RAMP_TIME .
./.svn/pristine/05/0574680922f59e07bd49e16a951d69421690a323.svn-base:
int val = ioctlSet(V4L2_CID_FOCUS_AD5820_RAMP_TIME,
1000000.0f/diopterRateToTickRate(speed));
./src/N900/Lens.cpp:    int val =
ioctlSet(V4L2_CID_FOCUS_AD5820_RAMP_TIME,
1000000.0f/diopterRateToTickRate(speed));
pavel at duo:~/g/fcam-dev$ grep -ri RAMP_MODE .
./.svn/pristine/05/0574680922f59e07bd49e16a951d69421690a323.svn-base:
ioctlSet(V4L2_CID_FOCUS_AD5820_RAMP_MODE, 0);
./src/N900/Lens.cpp:    ioctlSet(V4L2_CID_FOCUS_AD5820_RAMP_MODE, 0);
pavel at duo:~/g/fcam-dev$

> I might as well drop the two controls, up to you. If someone ever needs them
> they can always be reintroduced. I'd be happy to get a new patch, the
> current driver patch does not compile (just tried) as the definitions of
> these controls are missing.

I'd prefer to keep the controls, as we have userspace using them. I
got it to compile but have yet to get it to work (subdevs split, so it
needs some modifications).

Best regards,
									Pavel
-- 
(english) http://www.livejournal.com/~pavelmachek
(cesky, pictures) http://atrey.karlin.mff.cuni.cz/~pavel/picture/horses/blog.html